/*
 * Camera.h
 *
 *  Created on: 28.08.2011
 *  Author: Manuel Hochmayr, e0627715@student.tuwien.ac.at
 */

#ifndef CAMERA_H_
#define CAMERA_H_

#include <android/log.h>
#include "cml/cml.h"


#define  LOG_TAG    "VoRMD"
#define  LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)

namespace vormd {

class Camera {
public:
	Camera();
	Camera(cml::vector3f vpos,cml::vector3f vtarget);
	void setPerspective(float width, float hight, float zNear, float zFar);
	cml::matrix44f_c getVP();
	cml::matrix44f_c getPerspective();
	cml::matrix44f_c getOrthoPerspective();
	cml::matrix44f_c getView();
	cml::matrix44f_c getVOP();
	void zoom(float zoom);
	void rotate(cml::matrix44f_c rotate);
	virtual ~Camera();

private:
	cml::matrix44f_c orthoprojection;
	cml::matrix44f_c projection;
	cml::matrix44f_c view;
	cml::vector3f view_position;
	cml::vector3f view_target;
	cml::vector3f up_direction;
	cml::vector3f forward_direction;
	float rotationX;
	float rotationY;
	float yaw;
	float yaw_backup;
	float pitch;
	float pitch_backup;

};



} /* namespace vormd */
#endif /* CAMERA_H_ */
