/*
 * Shadermanager.h
 *
 *  Created on: 17.08.2011
 *  Author: Manuel Hochmayr, e0627715@student.tuwien.ac.at
 */
#ifndef SHADERMANAGER_H_
#define SHADERMANAGER_H_

#include <android/log.h>

#include <GLES2/gl2.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <map>

#define  LOG_TAG    "VoRMD"
#define  LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)

namespace vormd {

class Shader {
public:
	GLuint programmID;
	GLuint textureentryHandle;
	GLuint textureexitHandle;
	GLuint texture3DHandle;
	GLuint vPositionHandle;
	GLuint vColorHandle;
	GLuint MVPMatrixHandle;
	GLuint texCoordHandle;
	GLuint textransferHandle;
	GLuint zCoordHandle;
	GLuint stepSize;
	GLuint textureScale;
	GLuint renderMode;
	GLuint perfUpdate;
	GLuint slicingMode;
};

class Shadermanager {
public:


	Shadermanager();
	virtual ~Shadermanager();

	/**
	 * Creats the shader program
	 */
	Shader* createProgram(const char* pVertexSource,const char* pFragmentSource);

	/**
	 * Returns the shader
	 */
	Shader* popShader(int type);

private:
	/**
	 * Method to load a single shader
	 */
	GLuint loadShader(int shaderType, const char* pSource);

	/**
	 * Puts a shader to the hashmap
	 */
	void putShader(int type, Shader* shader);

	/**
	 * Checks for GL errors
	 */
	void checkGlError(const char* op);

	//Vector where all shaders are saved.
	std::map<int, Shader*> shaderMap;
};

} /* namespace vormd */
#endif /* SHADERMANAGER_H_ */
