/*
 * TransferFunction.cpp
 *
 *  Created on: 03.12.2011
 *      Author: Manuel
 */

#include "TransferFunction.h"

namespace vormd {

TransferFunction::TransferFunction() {
	loadedTransfer = false;

}

TransferFunction::~TransferFunction() {
	// TODO Auto-generated destructor stub
}

void TransferFunction::createStandardTransferFunction()
{
		unsigned char* data;
		unsigned width = 4096;

		tfpoint start;
		tfpoint one;
		tfpoint two;
		tfpoint three;
		tfpoint end;

		start.r = 0;
		start.g = 0;
		start.b = 0;
		start.a = 0;
		start.pos = 0;

		one.r = 0;
		one.g = 0;
		one.b = 0;
		one.a = 0;
		one.pos = 556;

		two.r = 255;
		two.g = 0;
		two.b = 0;
		two.a = 217;
		two.pos = 934;

		three.r = 170;
		three.g = 0.0f;
		three.b = 0.0f;
		three.a = 0.0f;
		three.pos = 3182;

		end.r = 0;
		end.g = 0;
		end.b = 0;
		end.a = 0;
		end.pos = 4096;

		points.push_back(start);
		points.push_back(one);
		points.push_back(two);
		points.push_back(three);
		points.push_back(end);

		data = (unsigned char*) malloc(4 * width * sizeof(unsigned char));
		memset(data, 0, 4 * width * sizeof(unsigned char));

		tfpoint pPoint = points[0];

		for (unsigned int i = 1; i < points.size(); i++) {
			tfpoint actPoint = points[i];
			unsigned int distance = actPoint.pos - pPoint.pos;
			for (unsigned int j = 0; j < distance; j++) {
				data[(pPoint.pos + j) * 4 + 0] = pPoint.r+ (actPoint.r - pPoint.r)* ((float) (j + 1) / (float) distance);
				data[(pPoint.pos + j) * 4 + 1] = pPoint.g+ (actPoint.g - pPoint.g)* ((float) (j + 1) / (float) distance);
				data[(pPoint.pos + j) * 4 + 2] = pPoint.b+ (actPoint.b - pPoint.b)* ((float) (j + 1) / (float) distance);
				data[(pPoint.pos + j) * 4 + 3] = pPoint.a+ (actPoint.a - pPoint.a)* ((float) (j + 1) / (float) distance);
			}

			pPoint = actPoint;
		}

		glGenTextures(1, &transferTexture);
		glBindTexture(GL_TEXTURE_2D, transferTexture);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, 1, 0, GL_RGBA,GL_UNSIGNED_BYTE, data);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glBindTexture(GL_TEXTURE_2D, 0);

		loadedTransfer = true;

		delete data;
}

void TransferFunction::LoadTransferTexture(int width,unsigned char* data)
{
	if(loadedTransfer){
		glDeleteTextures(1,&transferTexture);
		loadedTransfer = false;
	}

	LOGI("TRANSFERPICHIGHT: %i",width);

	glGenTextures(1, &transferTexture);
	glBindTexture(GL_TEXTURE_2D, transferTexture);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, 1, 0, GL_RGBA,GL_UNSIGNED_BYTE, data);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glBindTexture(GL_TEXTURE_2D, 0);

	loadedTransfer = true;


}

GLuint TransferFunction::getTransferTexture()
{
	return transferTexture;
}

} /* namespace vormd */
