/*
 * TransferFunction.h
 *
 *  Created on: 03.12.2011
 *  Author: Manuel Hochmayr, e0627715@student.tuwien.ac.at
 */

#ifndef TRANSFERFUNCTION_H_
#define TRANSFERFUNCTION_H_


#include <vector>

#include <stdlib.h>

#include <GLES2/gl2.h>
#include <GLES2/gl2ext.h>

#include <android/log.h>


#define  LOG_TAG    "VoRMD"
#define  LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)

struct tfpoint {
		unsigned char r;
		unsigned char g;
		unsigned char b;
		unsigned char a;
		unsigned int pos;
};

namespace vormd {


class TransferFunction {

public:
	TransferFunction();
	virtual ~TransferFunction();

	/*
	 * Creats a red standard transfer function. Optimized for the lobster
	 */
	void createStandardTransferFunction();

	/**
	 * Method to bind a loaded transfer png to the GPU
	 */
	void LoadTransferTexture(int width,unsigned char* data);

	/**
	 * Returns the transfer texture ID
	 */
	GLuint getTransferTexture();

	GLuint transferTexture;

private:
	bool loadedTransfer;
	std::vector<tfpoint> points;
};

} /* namespace vormd */
#endif /* TRANSFERFUNCTION_H_ */
