package com.vormd;

import android.util.Log;
import android.view.ScaleGestureDetector;
import android.view.ScaleGestureDetector.SimpleOnScaleGestureListener;
/**
 * Class for handeling the two finger touch input to do the scaling
 * @author Manuel Hochmayr, e0627715@student.tuwien.ac.at
 *
 */
public class  ScaleListener extends SimpleOnScaleGestureListener {
	
	static final String logTag = "ScaleDetector";
	float mScaleFactor;
	
	@Override
    public boolean onScale(ScaleGestureDetector detector) {
        mScaleFactor *= detector.getScaleFactor();
        
        mScaleFactor = Math.max(1.0f, Math.min(mScaleFactor, 1.8f));
        VoRMDJNILIB.scale(mScaleFactor);

        //Log.i(logTag, "Scaling: " + mScaleFactor);
      
        return true;
    }

}
