package com.vormd;

import android.content.res.AssetManager;
import android.graphics.Bitmap;

/**
 * Class representing the interface between the NDK (C++) and the SDK (JAVA)
 * @author Manuel Hochmayr, e0627715@student.tuwien.ac.at
 *
 */

public class VoRMDJNILIB {

	  /*
	    * Load the 'fileloader1' shared library
	    */
	    static {
	    System.loadLibrary("VoRMD");
	    }
	    
	    public native static boolean assetloadFile(AssetManager asset,String fileName);
	    public native static boolean loadFile(String fileName);
	    public native static boolean loadTransferPNG(Bitmap bitmap,boolean usingSTF);
	    public native static void init(int width, int height);
	    public native static void draw(int mode);
	    public native static void rotateLeft();
	    public native static void rotateRight();
	    public native static void rotateUp();
	    public native static void rotateDown();
	    public native static void scale(float scalefactor);
	    public native static float getFPS();
	    public native static int getVolumeDepth();
	    public native static int getVolumeHeight();
	    public native static int getVolumeWidth();
	    public native static void setZCoord(int coord);
	    public native static void setXCoord(int coord);
	    public native static void setYCoord(int coord);
	    public native static void setDz(float dz);
	    public native static void setAdaptiv(boolean adapt);
	    public native static void performingUpdate(boolean update);
	    public native static void setSlicingMode(int mode);
	    public native static void quitApp();
	   
}
